<!-- This button has two routes to use: -->
<!-- - set the @click with your own function (make sure you set the succes if you want to see that) -->
<!-- - set a endpoint to let the button handle state -->
<script setup lang="ts">
import Spinner from './spinner.vue';
import { watch, ref } from 'vue';
export type State = "ENABLED" | "LOADING" | "SUCCESS" | "DISABLED";

interface Props {
    state?: State,
    enabledText?: string,
    loadingText?: string,
    successText?: string,
    onClick?: () => Promise<void>
}

const props = withDefaults(defineProps<Props>(), {
    enabledText: 'Enabled',
    loadingText: 'Loading...',
    successText: 'Success!',
});

const internalState = ref(props.state || "ENABLED");

watch(() => props.state, (newState) => {
    if (newState)
        internalState.value = newState;
});

async function handleClick() {
    if (props.state !== "ENABLED" || !props.onClick) {
        return;
    }
    internalState.value = "LOADING";

    await props.onClick();
    if (internalState.value === "LOADING") {
        internalState.value = "ENABLED";
    }
}
</script>

<template>
    <button @click="handleClick" :class="[
        'button',
        internalState === 'ENABLED' ? 'cursor-pointer' : '',
        internalState === 'SUCCESS' ? 'success cursor-not-allowed' : '',
        internalState === 'DISABLED' ? 'disabled cursor-not-allowed' : '',
        internalState === 'LOADING' ? 'loading cursor-progress' : ''
    ]" :disabled="internalState !== 'ENABLED'">
        <div v-if="internalState === 'LOADING'" class="flex items-center flex-row gap-3 h-full">
            <Spinner />
            <span v-if="loadingText">{{ loadingText }}</span>
       
        </div>
        <div v-else>
            {{ internalState === 'ENABLED' ? enabledText : '' }}
            {{ internalState === 'SUCCESS' ? successText : '' }}
            {{ internalState === 'DISABLED' ? 'Disabled' : '' }}
        </div>
    </button>
</template>


<style>
.button {
    @apply rounded-3xl h-12 mt-5 font-bold px-4 py-2;
    @apply flex justify-center;
    @apply p-3 font-sans shadow-md shadow-gray-800/20 transition-all;
    @apply focus:opacity-[0.85] focus:shadow-none active:opacity-[0.85];

    width: 100%;
    background: var(--buttonColor);
    color: var(--buttonTextColor);
    transition: all 0.3s;
    filter: brightness(90%);

    &:hover {
        filter: brightness(95%);
        @apply shadow-lg shadow-gray-800/20;
    }

    &:active{
        filter: brightness(85%);
        @apply shadow-none opacity-[0.85];
    }

    &:disabled{
        @apply shadow-none opacity-50;
    }
}
</style>